#ifndef SIMULATOR_H
#define SIMULATOR_H

#include "qosmanager.h"
#include "qosmanagerinterface.h"
#include "thread.h"
#include "mytools.h"
#include "tools.h"
#include <fstream>
#include "strings.h"
#include <vector>
#include "futureeventlist.h"
#include "events.h"
#include "qmi.h"

namespace Coral {

class Simulator : public Thread {
 public:
  Simulator();
  void readTypes();
  ofstream outfile;
 private:
  void run();
  vector<TransportInfo> type;
  FutureEventList FEL;

  card32 sessionID[100];
  card32 flowID[100][100];

  QoSManager qm;
  QMI        qmi;
};

}
#endif
